//+------------------------------------------------------------------+
//|                                                        DT_ZZ.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Blue
#property indicator_color3 Red
//---- indicator parameters
extern int ExtDepth=12;
//---- indicator buffers
double zzL[];
double zzH[];
double zz[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
 //  IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexArrow(2,174);
   SetIndexArrow(1,174);
//---- indicator buffers mapping
   SetIndexBuffer(0,zz);
   SetIndexBuffer(1,zzH);
   SetIndexBuffer(2,zzL);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
     
//---- indicator short name
   IndicatorShortName("DT_ZZ("+ExtDepth+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,shift,pos,lasthighpos,lastlowpos,curhighpos,curlowpos;
   double low_0,high_0,high_1,low_1;
   double min, max;
   ArrayInitialize(zz,0.0);
   ArrayInitialize(zzL,0.0);
   ArrayInitialize(zzH,0.0);
   
//   Comment("Bars = ", Bars); // It will show no of bars for all the time on top left in chart window.
   
   
   lasthighpos=Bars; lastlowpos=Bars;     // int variables 'lasthighpos & lastlowpos' are equal to no of bars.
   low_1=Low[Bars];high_1=High[Bars]; // 1st bar's low set to 'lastlow' & high of the same bar set to 'high_1'.
  
    
   for(shift=Bars-ExtDepth; shift>=0; shift--)   // Created a loop the begining from 13th no bar up to current bar, the 1st block of 12 bar(ExtDepth) will ignored.
   {     
      curlowpos=Lowest(NULL,0,MODE_LOW,ExtDepth,shift);  // i assume that its checking the lowest of bars and put bar no in to 'curlowpos'
      low_0=Low[curlowpos];
            
      curhighpos=Highest(NULL,0,MODE_HIGH,ExtDepth,shift);
      high_0=High[curhighpos];
      //------------------------------------------------
      if( low_0 >= low_1 ) { low_1 = low_0; }   // if the price is going up then set 'curlow' to 'lastlow'
      else                                            // else if the price is not going to up then run following code
         { 
            if( lasthighpos > curlowpos  )            // if the last high is in recent history's bars
            { 
            zzL[curlowpos]=low_0;                    // put a mark on current low bar.
               ///*
              min=100000; pos=lasthighpos;            //
               for(i=lasthighpos; i>=curlowpos; i--)  // if lasthighpos is > curlowpos then less lasthighpos by 1 dwn to curlowpos. 
                  {                                         // during the each decrement of lasthighpos to lastlowpos*
//                   Alert("i/lasthighpos = ",lasthighpos, "curlowpos = ", curlowpos,"min = ",min);
                    if (zzL[i]==0.0) continue;              // * finding lasthighpos bar's low is equal to
                    if (zzL[i]<min) { min=zzL[i]; pos=i; }  //
                    zz[i]=0.0;                              //
                  } 
               zz[pos]=min;
               //*/
            }
          //Alert("low_0 = ",low_0,"------","low_1 = ",low_1); 
          lastlowpos=curlowpos;
          low_1=low_0; 
         }
      //--- high
      if( high_0<=high_1 )  { high_1=high_0;}
      else
         {  
            //  
            if( lastlowpos>curhighpos ) 
            {  
            zzH[curhighpos]=high_0;
           ///*
               max=-100000; pos=lastlowpos;
               for(i=lastlowpos; i>=curhighpos; i--)
                  { 
                    if (zzH[i]==0.0) continue;
                    if (zzH[i]>max) { max=zzH[i]; pos=i; }
                    zz[i]=0.0;
                  } 
               zz[pos]=max;
           //*/     
            }  
         //Alert("high_0 = ",high_0,"------","high_1 = ",high_1);   
         lasthighpos=curhighpos;
         high_1=high_0;    
         
         }       
    }
//--------------------code added for EA---------------------+
// i add code for search peaks in the DT_ZZ indicator and   |
// its work fine but when i put the same code in EA its not |
// work i am afraid.                                        |
//----------------------------------------------------------+

      double peak1;
      for(int x = Bars; x > 0; x--)
            {
            if(zz[x] == zzH[x] && zz[x] > 0.0001)
               {
               peak1 = zzH[x];
               Alert(peak1);
               }
            }

 return(0);
}
//+------------------------------------------------------------------+